dofile_once("data/scripts/lib/utilities.lua")
dofile_once( "mods/toastline_pack/config.lua" )

function do_money_drop( amount_multiplier )	
	
	
	if ( GameGetIsTrailerModeEnabled() ) then return end
	
	local entity = GetUpdatedEntityID()
	local x, y,rot,xs,ys = EntityGetTransform( entity )
	local rand = math.random( 0, 9999 )
	
	local filled=true
	stacks=0
	local player_entities = ( EntityGetWithTag( "player_unit" ) )
	if (player_entities~=nil and player_entities~=0) then
		for i,v in ipairs(player_entities) do
		
			edit_component_with_tag( v, "VariableStorageComponent", "hcpstacks", function(comp,vars) stacks=stacks+ComponentGetValue( comp, "value_int") end )
			
			local thp, tmhp
			edit_all_components(v,"DamageModelComponent", function(comp,vars) thp=ComponentGetValue(comp,"hp") end )
			edit_all_components(v,"DamageModelComponent", function(comp,vars) tmhp=ComponentGetValue(comp,"max_hp") end )
			if (thp<tmhp) then
				filled=false
			end
			
		end
	end
	
	local DropChance2=0
	
	--if PPGenerous and health is full, then always drop gold
	if (PPGenerous~=true or filled~=true) then
	
		if (StackForever==true) then
			--wow mathemagic asymptote tricks
			DropChance2=100-((100-DropChance)/math.pow(2,stacks-1))
		else
			DropChance2=stacks*DropChance
		end
		
	end
	

	if( rand < DropChance2*100 ) then 
		
		
		local amount = 1
		edit_component( entity, "DamageModelComponent", function(comp,vars)
			local health = tonumber(ComponentGetValue( comp, "max_hp"))
			
			if health > 1.0 then
				amount = math.floor(health)
			end
		
		end)
		amount = amount * amount_multiplier
		local money = amount 
		
		local increment=1000
		while money >= increment do
			hent=EntityLoad( "mods/toastline_pack/files/data/entities/items/pickup/health_container_1000.xml", x, y-8 )
			money = money - increment
		end	
		
		increment=100
		while money >= increment do
			hent=EntityLoad( "mods/toastline_pack/files/data/entities/items/pickup/health_container_100.xml", x, y-8 )
			money = money - increment
		end	
		
		increment=20
		while money >= increment do
			hent=EntityLoad( "mods/toastline_pack/files/data/entities/items/pickup/health_container_20.xml", x, y-8 )
			money = money - increment
		end	
		
		increment=5
		while money >= increment do
			hent=EntityLoad( "mods/toastline_pack/files/data/entities/items/pickup/health_container_5.xml", x, y-8 )
			money = money - increment
		end
		
		increment=1
		while money >= increment do
			hent=EntityLoad( "mods/toastline_pack/files/data/entities/items/pickup/health_container.xml", x, y-8 )
			money = money - increment
		end	

		
		
	else	
		local no_gold_drop = false
		edit_component_with_tag( entity, "VariableStorageComponent", "no_gold_drop", function(comp,vars) no_gold_drop = true end )
		
		if no_gold_drop then
			return
		end
		
		local amount = 1
		
		edit_component( entity, "DamageModelComponent", function(comp,vars)
			local health = tonumber(ComponentGetValue( comp, "max_hp"))

			if health > 1.0 then
				amount = math.floor(health)
			end
		
		end)

		amount = amount * amount_multiplier
		--[[if( amount > ( 15 * amount_multiplier ) ) then
			amount = 15 * amount_multiplier
		end]]--
		
		local money = 10 * amount
		--local x, y = EntityGetTransform( entity )
		
		
		while money >= 10000 do
			EntityLoad( "data/entities/items/pickup/goldnugget_10000.xml", x, y-8 )
			money = money - 10000
		end	
		
		while money >= 1000 do
			EntityLoad( "data/entities/items/pickup/goldnugget_1000.xml", x, y-8 )
			money = money - 1000
		end	

		while money >= 200 do
			EntityLoad( "data/entities/items/pickup/goldnugget_200.xml", x, y-8 )
			money = money - 200
		end	

		while money >= 50 do
			EntityLoad( "data/entities/items/pickup/goldnugget_50.xml", x, y-8 )
			money = money - 50
		end	

		while money >= 10 do
			EntityLoad( "data/entities/items/pickup/goldnugget_10.xml", x, y-8 )
			money = money - 10
		end	
	end
end

function death( damage_type_bit_field, damage_message, entity_thats_responsible, drop_items )
	do_money_drop( 1 )
end