table.insert( actions,
{
	id          = "AVOIDANCE",
	name 		= "avoidance",
	description = "Causes the projectile to attempt to avoid terrain",
	sprite 		= "mods/toastline_pack/files/actions/avoidance.png",
	sprite_unidentified = "data/ui_gfx/gun_actions/sinewave_unidentified.png",
	type 		= ACTION_TYPE_MODIFIER,
	spawn_level                       = "1,2,3,4,5", 
	spawn_probability                 = "1,1,1,1,1",
	price = 60,
	mana = 0,
	--max_uses = -1,
	action 		= function()
		c.extra_entities = c.extra_entities .. "mods/toastline_pack/files/actions/avoidance.xml,"
		draw_actions( 1, true )
	end,
})

table.insert( actions,
{
	id          = "CORRECTIVE_THRUST",
	name 		= "Corrective Thrust",
	description = "Causes the projectile to adjust its trajectory closer to the direction it was fired",
	sprite 		= "mods/toastline_pack/files/actions/dirthrust.png",
	sprite_unidentified = "data/ui_gfx/gun_actions/sinewave_unidentified.png",
	type 		= ACTION_TYPE_MODIFIER,
	spawn_level                       = "2,3,4,5", 
	spawn_probability                 = "1,1,1,1",
	price = 60,
	mana = 1,
	--max_uses = -1,
	action 		= function()
		c.extra_entities = c.extra_entities .. "mods/toastline_pack/files/actions/dirthrust.xml,"
		draw_actions( 1, true )
	end,
})



table.insert( actions,
{
	id          = "FURIOUS_BUILDUP",
	name 		= "Furious Buildup",
	description = "Gathers strength and enhances the projectile",
	sprite 		= "mods/toastline_pack/files/actions/furiousbuildup.png",
	sprite_unidentified = "data/ui_gfx/gun_actions/arc_electric_unidentified.png",
	type 		= ACTION_TYPE_MODIFIER,
	spawn_level                       = "2,3,4,5,6", 
	spawn_probability                 = "1,1,1,1,1",
	price = 300,
	mana = 60,--80
	--max_uses = -1,
	action 		= function()
		--c.extra_entities = c.extra_entities .. "mods/toastline_pack/files/actions/buildup2.xml,"
		--draw_actions( 1, true )
		if reflecting then 
			Reflection_RegisterProjectile( entity_filename )
			return 
		end
		local d=c.extra_entities
		
		
		
		BeginProjectile( "mods/toastline_pack/files/actions/buildup.xml" )
		BeginTriggerDeath()
			
			local shot = create_shot( 1 );
			local c = shot.state;
			c.extra_entities = c.extra_entities .. "mods/toastline_pack/files/actions/buildup2.xml,"..d
			
			if (string.find(c.extra_entities,"mods/toastline_pack/files/actions/fbuildup2b.xml,")==nil) then
				c.extra_entities = c.extra_entities .."mods/toastline_pack/files/actions/fbuildup2b.xml,"
			end
			
			if (string.find(c.extra_entities,"mods/toastline_pack/files/actions/fbuilduprescale.xml,")==nil) then
				c.extra_entities = c.extra_entities .."mods/toastline_pack/files/actions/fbuilduprescale.xml,"
			end
			--c.fire_rate_wait = c.fire_rate_wait + 30
			draw_shot( shot, true );
		EndTrigger()
		EndProjectile()
		

	end,
})