dofile( "data/scripts/lib/utilities.lua" )

local entity_id    = GetUpdatedEntityID()
local pos_x, pos_y= EntityGetTransform( entity_id )



local vel_x=0
local vel_y=0
local oldvel_x=0
local oldvel_y=0
local oldspd=0
local newspd=0

local tryvels=EntityGetComponent(entity_id, "VelocityComponent" )
if (tryvels==nil) then --if it doesn't have a VelocityComponent already, we must add one, and then get the velocities

	EntityAddComponent( entity_id, "VelocityComponent", 
	{
	}
	)
	
end

local ourProjectileComponent = EntityGetComponent(entity_id, "ProjectileComponent")
	if(ourProjectileComponent ~= nil and ourProjectileComponent ~= 0) then
		local shooter = ComponentGetValue( ourProjectileComponent[1], "mWhoShot") --get the entity that fired
		if(shooter ~= nil)then

			local ctrls=EntityGetComponent(shooter, "ControlsComponent" )
			if (ctrls~=nil and ctrls ~= 0) then
					vel_x,vel_y = ComponentGetValueVector2( ctrls[1], "mAimingVectorNormalized", vel_x, vel_y)
				end
			end
		
		end
	end
end


GamePrintImportant(tostring(vel_x),tostring(vel_y))

edit_component( entity_id, "VelocityComponent", function(comp,vars)

	oldvel_x,oldvel_y = ComponentGetValueVector2( comp, "mVelocity", vel_x, vel_y)

	
	ComponentSetValueVector2( comp, "mVelocity", oldvel_x+vel_x, oldvel_y+vel_y)
	
	
	
end)


PhysicsApplyForce( entity_id, vel_x, vel_y)