dofile( "data/scripts/lib/utilities.lua" )

local entity_id    = GetUpdatedEntityID()
local pos_x, pos_y = EntityGetTransform( entity_id )
local hitboxes = EntityGetComponent(entity_id, "HitboxComponent" )
local vel = (EntityGetComponent(entity_id, "VelocityComponent" ))[1]


local vel_x=0
local vel_y=0
local oldvel_x=0
local oldvel_y=0
local targetspd=50
local newspd=0


--save current speed vectors
oldvel_x,oldvel_y = ComponentGetValueVector2( vel, "mVelocity", oldvel_x, oldvel_y)
local oldspd=math.max(1,math.sqrt( (oldvel_x)^2 + (oldvel_y)^2 ))

--two hitscans in opposing perpendiculars to the current direction
local distout=14
local oldvel_x2=distout*oldvel_x/oldspd
local oldvel_y2=distout*oldvel_y/oldspd
distout=12


--local emitters = EntityGetComponent(entity_id, "ParticleEmitterComponent" )
--ComponentSetValueVector2( emitters[1], "offset",0, -500)
--ComponentSetValueVector2( emitters[2], "offset",oldvel_y2, -oldvel_x)


	
local normalfound,normalx,normaly,normaldist = GetSurfaceNormal(pos_x-oldvel_y2, pos_y+oldvel_x2, distout, 24 )
local scale=0
--ComponentSetValueVector2( emitters[2], "offset",0, -500)
if normalfound then
	--push or pull according to the distance, in the corresponding perpendicular
	--normaldist=math.sqrt( (normalx)^2 + (normaly)^2 )
	scale=((normaldist/distout)-.99)
	
	--ComponentSetValueVector2( emitters[1], "offset",-normalx*normaldist, -normaly*normaldist)
	
	--find the normal's perpendicular that is least different from the original direction
	local angle=math.atan2(normaly,normalx)
	local ang_x=math.cos(angle+math.pi/2)
	local ang_y=math.sin(angle+math.pi/2)
	
	
	vel_x = vel_x + normalx*scale*30-ang_x*50
	vel_y = vel_y + normaly*scale*30-ang_y*50
	
	local arcent= shoot_projectile( entity_id, "mods/toastline_pack/files/actions/smalllightning.xml", pos_x, pos_y, normalx*300+oldvel_x, normaly*300+oldvel_y )


	--GamePrint(tostring(scale))
	
end

local normalfound,normalx,normaly,normaldist = GetSurfaceNormal(pos_x+oldvel_y2, pos_y-oldvel_x2, distout, 24 )
local scale=0
--ComponentSetValueVector2( emitters[2], "offset",0, -500)
if normalfound then
	--push or pull according to the distance, in the corresponding perpendicular
	--normaldist=math.sqrt( (normalx)^2 + (normaly)^2 )
	scale=((normaldist/distout)-.99)
	
	--ComponentSetValueVector2( emitters[1], "offset",-normalx*normaldist, -normaly*normaldist)
	
	--find the normal's perpendicular that is least different from the original direction
	local angle=math.atan2(normaly,normalx)
	local ang_x=math.cos(angle+math.pi/2)
	local ang_y=math.sin(angle+math.pi/2)
	
	
	vel_x = vel_x + normalx*scale*30+ang_x*50
	vel_y = vel_y + normaly*scale*30+ang_y*50
	
	local arcent= shoot_projectile( entity_id, "mods/toastline_pack/files/actions/smalllightning.xml", pos_x, pos_y, normalx*300+oldvel_x, normaly*300+oldvel_y )

	--ComponentSetValueVector2( emitters[2], "offset",ang_x*16, ang_y*16)
	
	
	
end



if (vel_x~=0 or vel_y~=0) then

oldspd=math.sqrt( (vel_x)^2 + (vel_y)^2 )

vel_x=vel_x*50/oldspd
vel_y=vel_y*50/oldspd



ComponentSetValueVector2( vel, "mVelocity", oldvel_x*.5+vel_x*.5, oldvel_y*.5+vel_y*.5)

end



--set speed to OR closer to desired speed
