dofile( "data/scripts/lib/utilities.lua" )
dofile( "mods/toastline_pack/config.lua" )

table.insert( perk_list,
	{
	id = "SEGMENTED_REGENERATION",
	ui_name = "Segmentation",
	ui_description = "Regenerate HP in segments, but you lose some maximum health.",
	ui_icon = "mods/toastline_pack/files/segmentperk/segmentation_ui.png",
	perk_icon = "mods/toastline_pack/files/segmentperk/segmentation_perk.png",
	stackable = STACKABLE_MAX_AMOUNT,
	func = function( entity_perk_item, entity_who_picked, item_name )
		--local Entity = EntityLoad( "data/scripts/regenerationentity.xml",0,0 )
		
		edit_all_components( entity_who_picked, "DamageModelComponent", function(comp,vars)
		
		ComponentSetValue( comp, "max_hp",math.max(1/25,ComponentGetValue( comp, "max_hp")*(1-SegLifeCost)))
		
		end)
		
	
		local edit=1
		edit_all_components( entity_who_picked, "VariableStorageComponent", function(comp,vars)
		if (ComponentGetValue( comp, "name")=="prpp") then
				edit=edit+tonumber(ComponentGetValue( comp, "value_int"))
				ComponentSetValue( comp,"value_int", edit)
				--GamePrint("a"..tostring(edit))
			end
		end)
		
		
		if (edit==1) then
			EntityAddComponent( entity_who_picked, "VariableStorageComponent", 
				{
				name = "prpp",
				value_int = "1",
				}
			)
		end
		
		
		--GamePrint("b"..tostring(edit))
	end,
	}
 )
