dofile( "data/scripts/lib/utilities.lua" )

local entity_id    = GetUpdatedEntityID()
local pos_x, pos_y,rot,xs,ys = EntityGetTransform( entity_id )
local hitboxes = EntityGetComponent(entity_id, "HitboxComponent" )
local edit=0;
local multiplier=1;
local submult=0;
local multrt=1





--GamePrint(tostring(EntityGetName( shooter )))
--multiplier=multiplier+edit
--submult=submult+edit

edit_all_components( entity_id, "VariableStorageComponent", function(comp,vars)
	if (ComponentGetValue( comp, "name")=="fblevel") then
			
			edit=edit+tonumber(ComponentGetValue( comp, "value_int"))
			--GamePrint(tostring(ComponentGetValue( comp, "value_int")))
			ComponentSetValue( comp,"value_int", edit)
			
			--GamePrint("m"..tostring(ComponentGetValue( comp, "value_int")))
		end
		--GamePrint(ComponentGetValue( comp, "name"))
end)

multiplier=multiplier+edit
submult=submult+edit
multrt=math.sqrt(multiplier)

--GamePrint("m"..tostring(multiplier))

EntitySetTransform( entity_id, pos_x, pos_y, rot, xs*multrt, ys*multrt )


edit_all_components( entity_id, "VelocityComponent", function(comp,vars)
	edit=ComponentGetValue( comp, "mass")*multiplier
	ComponentSetValue(comp,"mass",edit)
end)

edit_all_components( entity_id, "DamageModelComponent", function(comp,vars)

	ComponentSetValue(comp,"hp",ComponentGetValue( comp, "hp")*multiplier)
end)



edit_all_components( entity_id, "ProjectileComponent", function(comp,vars)


	

	edit=1;
	edit=ComponentGetValue( comp, "damage")*multiplier
	ComponentSetValue( comp, "damage", edit)

	--todo: lifetime modifiers act screwy with this
	if (EntityGetName( entity_id )~="fbuildup") then
		edit=tonumber(ComponentGetValue( comp, "lifetime"))
		if (edit>0) then
			ComponentSetValue( comp, "lifetime", edit*multiplier)
		end
	end

	ComponentSetValue( comp, "shoot_light_flash_radius", tonumber(ComponentGetValue( comp, "shoot_light_flash_radius"))*multrt)
	ComponentSetValue( comp, "knockback_force", tonumber(ComponentGetValue( comp, "knockback_force"))*multiplier)
	ComponentSetValue( comp, "bounces_left", tonumber(ComponentGetValue( comp, "bounces_left"))*multiplier)
	ComponentSetValue( comp, "ground_penetration_coeff", tonumber(ComponentGetValue( comp, "ground_penetration_coeff"))*multiplier)
	--ComponentSetValue( comp, "bounce_at_any_angle", 1)

	
	ComponentObjectSetValue( comp, "damage_by_type", "fire", ComponentObjectGetValue( comp, "damage_by_type", "fire" )*multiplier)
	ComponentObjectSetValue( comp, "damage_by_type", "slice", ComponentObjectGetValue( comp, "damage_by_type", "slice" )*multiplier)
	ComponentObjectSetValue( comp, "damage_by_type", "drill", ComponentObjectGetValue( comp, "damage_by_type", "drill" )*multiplier)
	ComponentObjectSetValue( comp, "damage_by_type", "healing", ComponentObjectGetValue( comp, "damage_by_type", "healing" )*multiplier)
	ComponentObjectSetValue( comp, "damage_by_type", "electricity", ComponentObjectGetValue( comp, "damage_by_type", "electricity" )*multiplier)
	ComponentObjectSetValue( comp, "damage_by_type", "melee", ComponentObjectGetValue( comp, "damage_by_type", "melee" )*multiplier)
	ComponentObjectSetValue( comp, "damage_by_type", "ice", ComponentObjectGetValue( comp, "damage_by_type", "ice" )*multiplier)
	
	
	
	ComponentObjectSetValue( comp, "config_explosion", "camera_shake", ComponentObjectGetValue( comp, "config_explosion", "camera_shake" )*multiplier*.6)
	ComponentObjectSetValue( comp, "config_explosion", "explosion_radius", ComponentObjectGetValue( comp, "config_explosion", "explosion_radius" )*multiplier)
	ComponentObjectSetValue( comp, "config_explosion", "max_durability_to_destroy", ComponentObjectGetValue( comp, "config_explosion", "max_durability_to_destroy" )+multiplier-1)
	ComponentObjectSetValue( comp, "config_explosion", "damage", ComponentObjectGetValue( comp, "config_explosion", "damage" )*multiplier)
	ComponentObjectSetValue( comp, "config_explosion", "stains_radius", ComponentObjectGetValue( comp, "config_explosion", "stains_radius" )*multiplier)
	ComponentObjectSetValue( comp, "config_explosion", "ray_energy", ComponentObjectGetValue( comp, "config_explosion", "ray_energy" )*multiplier)

	
	ComponentObjectSetValue( comp, "config_explosion", "sparks_count_max", ComponentObjectGetValue( comp, "config_explosion", "sparks_count_max" )*multrt)
	ComponentObjectSetValue( comp, "config_explosion", "sparks_count_min", ComponentObjectGetValue( comp, "config_explosion", "sparks_count_min" )*multrt)
	ComponentObjectSetValue( comp, "config_explosion", "material_sparks_count_max", ComponentObjectGetValue( comp, "config_explosion", "material_sparks_count_max" )*multrt)
	ComponentObjectSetValue( comp, "config_explosion", "material_sparks_count_min", ComponentObjectGetValue( comp, "config_explosion", "material_sparks_count_min" )*multrt)
	
	--TODO: this appears not to be possible
	--ComponentObjectSetValueValueRange(comp, "config_explosion", "physics_explosion_power", ComponentObjectGetValue( comp, "config_explosion", "physics_explosion_power.min" )*multiplier,ComponentObjectGetValue( comp, "config_explosion", "physics_explosion_power.max" )*multiplier)
	
	
	--edit=1
	--edit=ComponentGetValue( comp, "shoot_light_flash_radius")*multiplier
	--ComponentSetValue( comp, "shoot_light_flash_radius", edit)
	--GamePrint("s"..tostring(ComponentGetValue( comp, "damage")))
	
end)



edit_all_components( entity_id, "LightComponent", function(comp,vars)
	--edit=.04;
	edit=ComponentGetValue( comp, "radius")*multrt
	ComponentSetValue(comp,"radius",edit)
end)

edit_all_components( entity_id, "CellEaterComponent", function(comp,vars)
	edit=0;
	edit=ComponentGetValue( comp, "radius")*multrt
	--edit=math.sqrt(multiplier*ComponentGetValue( comp, "radius"))
	ComponentSetValue(comp,"radius",edit)
end)

local test=0;
edit_all_components( entity_id, "BlackHoleComponent", function(comp,vars)
	--edit=0;
	--edit=math.sqrt(multiplier*ComponentGetValue( comp, "radius")/multrt)
	--ComponentSetValue(comp,"radius",edit)
	
	edit=ComponentGetValue( comp, "damage_probability")*multiplier
	ComponentSetValue(comp,"damage_probability",edit)
	test=1
end)

if (test==1) then

	edit_all_components( entity_id, "VariableStorageComponent", function(comp,vars)

		if (ComponentGetValue( comp, "name")=="bhmaxrad") then
			ComponentSetValue( comp,"value_int", tonumber(ComponentGetValue( comp, "value_int"))*multrt)
		end
	end)
	--todo: increase radius indicator sprite
end


edit_all_components( entity_id, "ParticleEmitterComponent", function(comp,vars)
		
		ComponentSetValue(comp,"x_vel_min",tonumber(ComponentGetValue(comp,"x_vel_min"))*multiplier)
		ComponentSetValue(comp,"x_vel_max",tonumber(ComponentGetValue(comp,"x_vel_max"))*multiplier)
		ComponentSetValue(comp,"y_vel_min",tonumber(ComponentGetValue(comp,"y_vel_min"))*multiplier)
		ComponentSetValue(comp,"y_vel_max",tonumber(ComponentGetValue(comp,"y_vel_max"))*multiplier)
		if (EntityGetName( entity_id )~="fbuildup") then
			ComponentSetValue(comp,"lifetime_min",tonumber(ComponentGetValue(comp,"lifetime_min"))*2)
			ComponentSetValue(comp,"lifetime_max",tonumber(ComponentGetValue(comp,"lifetime_max"))*2)
			
		else
			--ComponentSetValue(comp,"lifetime_min",tonumber(ComponentGetValue(comp,"lifetime_min"))*multrt)
			--ComponentSetValue(comp,"lifetime_max",tonumber(ComponentGetValue(comp,"lifetime_max"))*multrt)
			ComponentSetValue(comp,"attractor_force",tonumber(ComponentGetValue(comp,"attractor_force"))*multiplier)
			ComponentSetValue(comp,"count_min",tonumber(ComponentGetValue(comp,"count_min"))*multrt)
			ComponentSetValue(comp,"count_max",tonumber(ComponentGetValue(comp,"count_max"))*multiplier)
			
			
		end
		ComponentSetValue(comp,"trail_gap",tonumber(ComponentGetValue(comp,"trail_gap"))*.8)
		
end)


edit_all_components( entity_id, "HomingComponent", function(comp,vars)
		ComponentSetValue(comp,"detect_distance",math.min(1000,tonumber(ComponentGetValue(comp,"detect_distance"))*multiplier))

end)


edit_all_components( entity_id, "LifetimeComponent", function(comp,vars)
	ComponentSetValue(comp,"kill_frame",tonumber(ComponentGetValue(comp,"kill_frame"))*multiplier)
end)

edit_all_components( entity_id, "MagicConvertMaterialComponent", function(comp,vars)

	ComponentSetValue(comp,"radius",math.min(tonumber(ComponentGetValue(comp,"radius"))*multrt,512))
end)


edit_all_components( entity_id, "MagicXRayComponent", function(comp,vars)
		ComponentSetValue(comp,"radius",math.min(tonumber(ComponentGetValue(comp,"radius"))*multiplier,512))

end)

--todo: this doesn't work
--edit_all_components( entity_id, "MaterialSeaSpawnerComponent", function(comp,vars)
		--local edit2 =0
		
		--edit, edit2 = ComponentGetValueVector2( comp, "size" )
		--ComponentSetValueVector2(comp,"size",edit*multiplier,edit2*multiplier)
--end)

--todo: this doesn't quite sync up with the visual from the modifier
edit_all_components( entity_id, "AreaDamageComponent", function(comp,vars)

		edit, edit2 = ComponentGetValueVector2( comp, "aabb_min" )
		ComponentSetValueVector2(comp,"aabb_min",edit*multiplier,edit2*multiplier)
		edit, edit2 = ComponentGetValueVector2( comp, "aabb_max" )
		ComponentSetValueVector2(comp,"aabb_max",edit*multiplier,edit2*multiplier)
		ComponentSetValue(comp,"damage_per_frame",tonumber(ComponentGetValue(comp,"damage_per_frame"))*multiplier)

end)






--todo: increase size, propagate effects to entities created by the projectile






