dofile( "data/scripts/lib/utilities.lua" )

local entity_id    = GetUpdatedEntityID()
local pos_x, pos_y= EntityGetTransform( entity_id )



local vel_x=0
local vel_y=0
local oldvel_x=0
local oldvel_y=0


local tryvels=EntityGetComponent(entity_id, "VelocityComponent" )
if (tryvels==nil) then --if it doesn't have a VelocityComponent already, we must add one
	EntityAddComponent( entity_id, "VelocityComponent", 
	{
	}
	)
end


local angle=0
local action=1

local variablestorages = EntityGetComponent( entity_id, "VariableStorageComponent" )
if( variablestorages ~= nil ) then
	for i,variablestorage in ipairs(variablestorages) do
		if ( ComponentGetValue( variablestorage, "name" ) == "initial_angle" ) then		
		
			angle = tonumber(ComponentGetValue( variablestorage, "value_string" ))
			--this next part is a hack because bombs are acting dumb and not obeying the RULES
			if (angle==-10) then
				action=0
				
				local tryvels=EntityGetComponent(entity_id, "VelocityComponent" )
				vel_x,vel_y = ComponentGetValueVector2( tryvels[1], "mVelocity", vel_x, vel_y)
					if (vel_x~=0 or vel_y~=0) then
						angle=math.atan2(vel_y,vel_x)
						action=1
						ComponentSetValue(variablestorage,"value_string",tostring(angle))
					end
			end
		end
	end
end




--angle=angle+math.pi/2
--GamePrintImportant(tostring(angle),"um")

vel_x=math.cos(angle)*12*action
vel_y=math.sin(angle)*12*action



if (action==1) then

	oldvel_x,oldvel_y = ComponentGetValueVector2( tryvels[1], "mVelocity", oldvel_x, oldvel_y)
	
	
	ComponentSetValueVector2( tryvels[1], "mVelocity", oldvel_x*.94+vel_x, oldvel_y*.94+vel_y)
	
	
	PhysicsApplyForce( entity_id, vel_x-oldvel_x*.06, vel_y-oldvel_y*.06)

end

